Commit fbf70096 authored by Petter Reinholdtsen's avatar Petter Reinholdtsen

New init.d script interpreter /lib/init/init-d-script.

* Transform init.d/skeleton into an init.d script interpreter
  /lib/init/init-d-script in sysvinit-utils that can be reused by other
  init.d scripts to avoid duplicate code (Closes: #464854).  See
  init-d-script(5) for how to use it.
* Rewrite service to detect status support by running scripts with
  'status' as the argument, and look for usage description.
parent 7b41c961
......@@ -7,6 +7,12 @@ sysvinit (2.88dsf-50) UNRELEASED; urgency=low
[ Petter Reinholdtsen ]
* Added code to install startpar-upstart-inject.8 manual page in
sysvinit-utils.
* Transform init.d/skeleton into an init.d script interpreter
/lib/init/init-d-script in sysvinit-utils that can be reused by other
init.d scripts to avoid duplicate code (Closes: #464854). See
init-d-script(5) for how to use it.
* Rewrite service to detect status support by running scripts with
'status' as the argument, and look for usage description.
-- Thomas Goirand <zigo@debian.org> Sun, 09 Feb 2014 23:47:19 +0800
......
#!/bin/sh
# See init-d-script(5) for instructions on how to use this library.
#=============================================================================
# Define LSB log_* functions.
# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
# and status_of_proc is working.
. /lib/lsb/init-functions
# PATH should only include /usr/* if it runs after the mountnfs.sh
# script. Scripts running before mountnfs.sh should remove the /usr/*
# entries.
PATH=/sbin:/usr/sbin:/bin:/usr/bin
export PATH
is_call_implemented() {
command -V $1 > /dev/null 2>&1
}
do_usage() {
if is_call_implemented do_reload ; then
echo "Usage: $SCRIPTNAME {start|stop|status|reload|restart|try-restart|force-reload}" >&2
else
echo "Usage: $SCRIPTNAME {start|stop|status|restart|try-restart|force-reload}" >&2
fi
}
call() {
cmd="$1"
shift
if is_call_implemented ${cmd}_override ; then
${cmd}_override "$@"
else
${cmd} "$@"
fi
}
#
# Function that starts the daemon/service
#
# Return
# 0 if daemon has been started
# 1 if daemon was already running
# 2 if daemon could not be started
do_start_cmd() {
start-stop-daemon --start --quiet ${PIDFILE:+--pidfile ${PIDFILE}} \
--startas $DAEMON --name $NAME --test > /dev/null \
|| return 1
start-stop-daemon --start --quiet ${PIDFILE:+--pidfile ${PIDFILE}} \
--startas $DAEMON --name $NAME -- $DAEMON_ARGS \
|| return 2
# Add code here, if necessary, that waits for the process to be ready
# to handle requests from services started subsequently which depend
# on this one. As a last resort, sleep for some time.
}
do_start()
{
if is_call_implemented do_start_prepare ; then
call do_start_prepare
fi
[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
call do_start_cmd
case "$?" in
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
esac
if is_call_implemented do_start_cleanup ; then
call do_start_cleanup
fi
}
#
# Function that stops the daemon/service
#
# Return
# 0 if daemon has been stopped
# 1 if daemon was already stopped
# 2 if daemon could not be stopped
# other if a failure occurred
do_stop_cmd() {
start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 ${PIDFILE:+--pidfile ${PIDFILE}} --name $NAME
RETVAL="$?"
[ "$RETVAL" = 2 ] && return 2
# Wait for children to finish too if this is a daemon that forks
# and if the daemon is only ever run from this initscript.
# If the above conditions are not satisfied then add some other code
# that waits for the process to drop all resources that could be
# needed by services started subsequently. A last resort is to
# sleep for some time.
start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
[ "$?" = 2 ] && return 2
# Many daemons don't delete their pidfiles when they exit.
rm -f $PIDFILE
return $RETVAL
}
do_stop()
{
if is_call_implemented do_stop_prepare ; then
call do_stop_prepare
fi
[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
call do_stop_cmd
case "$?" in
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
esac
if is_call_implemented do_stop_cleanup ; then
call do_stop_cleanup
fi
}
do_restart() {
[ "$VERBOSE" != no ] && log_daemon_msg "Restarting $DESC" "$NAME"
call do_stop_cmd
call do_start_cmd
case "$?" in
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
esac
}
do_force_reload() {
if is_call_implemented do_reload ; then
call do_reload
else
call do_restart
fi
}
# Enable this using
# alias do_reload=do_reload_sigusr1
do_reload_sigusr1() {
log_daemon_msg "Reloading $DESC configuration files" "$NAME"
start-stop-daemon --oknodo --stop --signal 1 --quiet \
--pidfile "$PIDFILE" --exec "$DAEMON"
log_end_msg $?
}
do_status() {
status_of_proc "$DAEMON" "$NAME" && return 0 || return $?
}
if [ "$DEBUG" = "true" ] ; then
set -x
fi
SCRIPTNAME=$1
scriptbasename="$(basename $1)"
if [ "$scriptbasename" != "init-d-script" ] ; then
script="$1"
shift
. $script
else
exit 0
fi
NAME=${NAME:=$(basename $DAEMON)}
DESC=${DESC:=$NAME}
# Do not use pid file if $PIDFILE is 'none'. Otherwise, generate from
# $NAME or use the value provided by the init.d script.
if [ none = "$PIDFILE" ] ; then
PIDFILE=
elif [ -z "$PIDFILE" ] ; then
PIDFILE=/var/run/$NAME.pid
fi
# Exit if the package is not installed
if [ none != "$DAEMON" ] && [ ! -x "$DAEMON" ] ; then
exit 0
fi
# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME
# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh
if [ -t 0 ] ; then # Be verbose when called from a terminal
VERBOSE=yes
fi
case "$1" in
start)
call do_start
;;
stop)
call do_stop
;;
status)
call do_status
;;
reload)
if is_call_implemented do_reload ; then
do_reload
else
call do_usage
exit 3
fi
;;
force-reload)
call do_force_reload
;;
restart)
call do_restart
;;
try-restart)
log_daemon_msg "Trying to restart $DESC" "$NAME"
if call do_status > /dev/null 2>&1 ; then
call do_restart
log_end_msg $?
else
log_progress_msg "is not running."
log_end_msg 1
fi
;;
'')
call do_usage
exit 3
;;
*)
if is_call_implemented do_unknown ; then
call do_unknown "$1"
else
call do_usage
exit 3
fi
;;
esac
.\" -*- nroff -*-
.\" macros
.de EX \" Begin Example
. IP
. ft CW
. nf
. ne \\$1
..
.de EE \" End Example
. ft P
. fi
. PP
..
.de URL \" URL formatting
\\$2 \(la\\$1\(ra\\$3
..
.TH INIT-D-SCRIPT 5 "2014-02-09" "init-d-script" "File formats"
.SH NAME
init-d-script \- interpreter for short and simple init.d scripts.
.SH DESCRIPTION
Generic init.d script framework to reduce the redundant code in
/etc/init.d/. The goal is to create an init.d script that is Debian
and LSB compliant. When the Debian policy conflict with the LSB, the
Debian policy take preference. See
.URL http://refspecs.linuxfoundation.org/LSB_4.1.0/LSB-Core-generic/LSB-Core-generic/iniscrptact.html "The LSB specification"
for information about init.d scripts in the LSB.
.P
This is a simple example on how init-d-script can be used to start and
stop a daemon with PID file support:
.P
.EX
#!/lib/init/init-d-script
### BEGIN INIT INFO
# Provides: atd
# Required-Start: $syslog $time $remote_fs
# Required-Stop: $syslog $time $remote_fs
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: run at jobs
# Description: Debian init script to start the daemon
# running at jobs.
### END INIT INFO
DAEMON=/usr/sbin/atd
.EE
.P
In addition to the DEAMON setting, one can specify DESC, NAME,
PIDFILE (none means no PID file), or implement override functions
do_force_reload_override, do_reload_override, do_restart_override,
do_start_override, do_start_cmd_override, do_start_prepare,
do_start_cleanup do_status_override, do_stop_override,
do_stop_prepare, do_stop_cleanup and do_stop_cmd_override.
.P
If the daemon support reloading, implement the do_reload function to
make the init.d script recognize the reload operation as well as use
it for the force-reload operation.
.P
If DAEMON is 'none', the check to see if the daemon is installed is
disabled, and replacement functions do_start_cmd_override,
do_stop_cmd_override and do_status_override functions must be
implemented.
.P
Services supporting reload should define the do_reload function. If
the service handle reload using a SIGUSR1 signal, the following alias
can be used instead of implementing ones own do_reload function:
.P
.EX
alias do_reload=do_reload_sigusr1
.EE
.RE
.SH FILES
.TP
.I /lib/init/init-d-script
Bourne shell interpreter with implementation of init.d actions
.I /etc/init.d/
Location of init.d scripts.
.TP
.RE
.SH KNOWN BUGS/LIMITATIONS
Not yet documented
.SH AUTHOR
This manpage was written by Petter Reinholdtsen <pere@debian.org>.
.SH "SEE ALSO"
.BR inittab (8),
.BR service (8),
.BR update-rc.d (8).
......@@ -23,3 +23,4 @@ initscripts: init.d-script-should-depend-on-virtual-facility etc/init.d/mountall
initscripts: init.d-script-missing-dependency-on-remote_fs etc/init.d/mountnfs.sh: required-start
initscripts: init.d-script-missing-dependency-on-remote_fs etc/init.d/halt: required-stop
initscripts: init.d-script-possible-missing-stop etc/init.d/umountroot 1
initscripts: unusual-interpreter etc/init.d/skeleton #!/lib/init/init-d-script
......@@ -81,13 +81,14 @@ while [ $# -gt 0 ]; do
*)
if ! is_ignored_file "${SERVICE}" \
&& [ -x "${SERVICEDIR}/${SERVICE}" ]; then
if ! egrep -qs "\<status'?\)" "$SERVICE"; then
out=$(env -i LANG="$LANG" PATH="$PATH" TERM="$TERM" "$SERVICEDIR/$SERVICE" status 2>&1)
retval=$?
if echo "$out" | egrep -iq "usage:"; then
#printf " %s %-60s %s\n" "[?]" "$SERVICE:" "unknown" 1>&2
echo " [ ? ] $SERVICE" 1>&2
continue
else
out=$(env -i LANG="$LANG" PATH="$PATH" TERM="$TERM" "$SERVICEDIR/$SERVICE" status 2>&1)
if [ "$?" = "0" -a -n "$out" ]; then
if [ "$retval" = "0" -a -n "$out" ]; then
#printf " %s %-60s %s\n" "[+]" "$SERVICE:" "running"
echo " [ + ] $SERVICE"
continue
......
#! /bin/sh
#!/lib/init/init-d-script
### BEGIN INIT INFO
# Provides: skeleton
# Required-Start: $remote_fs $syslog
......@@ -7,7 +7,11 @@
# Default-Stop: 0 1 6
# Short-Description: Example initscript
# Description: This file should be used to construct scripts to be
# placed in /etc/init.d.
# placed in /etc/init.d. This example start a
# single forking daemon capable of writing a pid
# file. To get other behavoirs, implemend
# do_start(), do_stop() or other functions to
# override the defaults in /lib/init/init-d-script.
### END INIT INFO
# Author: Foo Bar <foobar@baz.org>
......@@ -15,145 +19,6 @@
# Please remove the "Author" lines above and replace them
# with your own name if you copy and modify this script.
# Do NOT "set -e"
# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="Description of the service"
NAME=daemonexecutablename
DAEMON=/usr/sbin/$NAME
DAEMON_ARGS="--options args"
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME
# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0
# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME
# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh
# Define LSB log_* functions.
# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
# and status_of_proc is working.
. /lib/lsb/init-functions
#
# Function that starts the daemon/service
#
do_start()
{
# Return
# 0 if daemon has been started
# 1 if daemon was already running
# 2 if daemon could not be started
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
|| return 1
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
$DAEMON_ARGS \
|| return 2
# Add code here, if necessary, that waits for the process to be ready
# to handle requests from services started subsequently which depend
# on this one. As a last resort, sleep for some time.
}
#
# Function that stops the daemon/service
#
do_stop()
{
# Return
# 0 if daemon has been stopped
# 1 if daemon was already stopped
# 2 if daemon could not be stopped
# other if a failure occurred
start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
RETVAL="$?"
[ "$RETVAL" = 2 ] && return 2
# Wait for children to finish too if this is a daemon that forks
# and if the daemon is only ever run from this initscript.
# If the above conditions are not satisfied then add some other code
# that waits for the process to drop all resources that could be
# needed by services started subsequently. A last resort is to
# sleep for some time.
start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
[ "$?" = 2 ] && return 2
# Many daemons don't delete their pidfiles when they exit.
rm -f $PIDFILE
return "$RETVAL"
}
#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
#
# If the daemon can reload its configuration without
# restarting (for example, when it is sent a SIGHUP),
# then implement that here.
#
start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
return 0
}
case "$1" in
start)
[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
do_start
case "$?" in
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
esac
;;
stop)
[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
do_stop
case "$?" in
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
esac
;;
status)
status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
;;
#reload|force-reload)
#
# If do_reload() is not implemented then leave this commented out
# and leave 'force-reload' as an alias for 'restart'.
#
#log_daemon_msg "Reloading $DESC" "$NAME"
#do_reload
#log_end_msg $?
#;;
restart|force-reload)
#
# If the "reload" option is implemented then remove the
# 'force-reload' alias
#
log_daemon_msg "Restarting $DESC" "$NAME"
do_stop
case "$?" in
0|1)
do_start
case "$?" in
0) log_end_msg 0 ;;
1) log_end_msg 1 ;; # Old process is still running
*) log_end_msg 1 ;; # Failed to start
esac
;;
*)
# Failed to stop
log_end_msg 1
;;
esac
;;
*)
#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
exit 3
;;
esac
DAEMON=/usr/sbin/daemonexecutablename
:
......@@ -11,3 +11,4 @@ usr/share/man/man8/killall5.8
usr/share/man/man8/pidof.8
usr/share/man/man8/sulogin.8
debian/service/service usr/sbin/
debian/init-d-script lib/init
debian/service/service.8
debian/init-d-script.5
Markdown is supported
0% or
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment